// The 'ConcreteCommand' class

  class CalculatorCommand implements Command{

    private char _operator;
    private int _operand;
    private Calculator _calculator;

    // Constructor

    public CalculatorCommand(Calculator calculator, char operator, int operand){

      this._calculator = calculator;
      this._operator = operator;
      this._operand = operand;

    }
    
    public void setOperator(char value){
        _operator = value; 
    }


   public void setOperand(int value){
        _operand = value; 
    }

    // Execute new command

    public void execute(){

      _calculator.operation(_operator, _operand);

    }

    // Unexecute last command

    public void unExecute(){

      _calculator.operation(undo(_operator), _operand);

    }

 

    // Returns opposite operator for given operator

    private char undo(char operator){

      switch (operator)

      {
        case '+': return '-';
        case '-': return '+';
        case '*': return '/';
        case '/': return '*';
        default: return 'e';
      }

    }

    public void printtt(){
        System.out.println("I'm command " + _operator + _operand);}
    
    
  }